name: Build

on:
  schedule:
    - cron: "0 0 * * 1"
  push:
    tags:        
      - 'manual_build'

jobs:
  build:
    steps:
      - name: Checkout
        uses: actions/checkout@v2

      - name: Check is image already exists
        id: extract-version
        run: |
          git clone https://github.com/ONLYOFFICE/DocumentServer
          cd DocumentServer
          docker_tag=$(git describe --tags --abbrev=0 | cut -d 'v' -f2-)
          echo $docker_tag
          echo "docker_tag=${docker_tag}" >> GITHUB_OUTPUT
          if curl --silent -f -lSL "https://hub.docker.com/v2/repositories/jiriks74/onlyoffice-documentserver/tags/${docker_tag}" > /dev/null; then exit 1; else exit 0; fi
        shell: bash

      - name: Remove temporary files
        id: remove-temp
        run: |
          echo ${{ steps.extract-version.outputs.docker_tag }}
          rm -rf DocumentServer
        shell: bash
      
      - name: Install Docker
        run: |
          apt-get update
          apt-get install docker.io -y          

      - name: Login to DockerHub
        uses: docker/login-action@v1
        with:
          username: ${{ secrets.DOCKERHUB_USERNAME }}
          password: ${{ secrets.DOCKERHUB_TOKEN }}

      - name: Set up QEMU
        uses: docker/setup-qemu-action@v2
      - name: Set up Docker Buildx
        uses: docker/setup-buildx-action@v1
        with:
          # driver-opts: network=host
          platforms: linux/amd64,linux/arm64

      - name: Build and push image
        uses: docker/build-push-action@v2
        with:
          push: true
          tags: jiriks74/onlyoffice-documentserver:${{ steps.extract-version.outputs.docker_tag }},jiriks74/onlyoffice-documentserver:latest
          platforms: linux/amd64,linux/arm64
          context: .
          file: ./Dockerfile
